SystemOrganization addCategory: #'WebTester-API'!
SystemOrganization addCategory: #'WebTester-Selenium'!
SystemOrganization addCategory: #'WebTester-Selenium-Tests'!

TestResource subclass: #WtSeleniumWebTesterTestResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

WtSeleniumWebTesterTestResource class
	instanceVariableNames: 'defaultAppRoot webTester'!

WtSeleniumWebTesterTestResource class
	instanceVariableNames: 'defaultAppRoot webTester'!

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:06'!
defaultAppRoot
	^ defaultAppRoot! !

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:06'!
defaultAppRoot: anObject
	defaultAppRoot := anObject! !

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:06'!
webTester
	^ webTester! !

!WtSeleniumWebTesterTestResource class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:06'!
webTester: anObject
	webTester := anObject! !

!WtSeleniumWebTesterTestResource methodsFor: 'running' stamp: 'BKBAG 5/10/2009 16:14'!
setUp
	|webTester|
	webTester := WtSeleniumWebTester new.
	webTester appRoot: self class defaultAppRoot.
	webTester start.
	self class webTester: webTester.! !

!WtSeleniumWebTesterTestResource methodsFor: 'running' stamp: 'BKBAG 5/10/2009 16:14'!
tearDown
	self class webTester stop.
	! !

WAComponent subclass: #WtMockApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

WtMockApplication class
	instanceVariableNames: 'expectedText'!

WtMockApplication class
	instanceVariableNames: 'expectedText'!

!WtMockApplication class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:50'!
expectedText
	^ expectedText! !

!WtMockApplication class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:50'!
expectedText: anObject
	expectedText := anObject! !

!WtMockApplication methodsFor: 'rendering' stamp: 'BKBAG 5/10/2009 17:18'!
renderContentOn: html 
	html text: self class expectedText! !

Object subclass: #WtWebTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-API'!

!WtWebTester commentStamp: 'BKBAG 5/10/2009 13:19' prior: 0!
WtWebTester defines an API for web tests

Instance Variables
!

WtWebTester subclass: #WtSeleniumWebTester
	instanceVariableNames: 'appRoot sessionId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumWebTester commentStamp: 'BKBAG 5/10/2009 13:20' prior: 0!
A WtSeleniumWebTester is a Selenium implementation for WtWebTester.

Instance Variables
	appRoot:		<Object>
	sessionId:		<Object>

appRoot
	- xxxxx

sessionId
	- xxxxx
!

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/25/2008 12:12'!
appRoot
	^appRoot! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 20:40'!
appRoot: anAppRoot
	appRoot := anAppRoot ! !

!WtSeleniumWebTester methodsFor: 'private' stamp: 'BKBAG 11/23/2008 21:02'!
commandToSeleniumRC: aCommandString 
	^ self requestToSeleniumRC: 'http://' , self defaultSeleniumHost , ':' , self defaultSeleniumPort printString , '/selenium-server/?cmd=' , aCommandString! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 12:55'!
defaultBrowser
	^'*chrome'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:01'!
defaultSeleniumHost
	^'localhost'! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:01'!
defaultSeleniumPort
	^4444! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/25/2008 12:16'!
fullAppRoot
	(self isAppRootSpecified)
		ifFalse:[^nil].
	(self appRoot startsWith: 'http://')
		ifTrue: [^appRoot]
		ifFalse: [^'http://', appRoot].! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/25/2008 12:13'!
isAppRootSpecified
	^self appRoot isNil not.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:26'!
isStarted
	^sessionId isNil not.! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 4/19/2009 15:08'!
isTextPresent: aString
	|result|
	result := self commandToSeleniumRC: 'isTextPresent&1=',aString encodeForHTTP,'&sessionId=',sessionId.
	(result beginsWith: 'OK')
	ifFalse: [self error: 'Could not query isTextPresent result was: ', result].
	^(result copyFrom: 4 to: result size) = 'true'.! !

!WtSeleniumWebTester methodsFor: 'actions' stamp: 'bkbag 4/17/2009 20:31'!
openUrl: anUrl
	|result|
	result := self commandToSeleniumRC: 'open&1=', anUrl, '&sessionId=', sessionId.
	(result beginsWith: 'OK')
	ifFalse: [self error: 'Could not open page ', anUrl, ' result was: ', result].! !

!WtSeleniumWebTester methodsFor: 'private' stamp: 'bkbag 4/19/2009 15:28'!
requestToSeleniumRC: aRequestUrl
	| request result urlWithProperHtmlEncoding|
	Transcript show: 'request to selenium:', aRequestUrl; cr.
	request := SptHTTPRequest new.
	request openGetTo: aRequestUrl.
	urlWithProperHtmlEncoding := SptHTTPUrl fromString: aRequestUrl.
	urlWithProperHtmlEncoding urlString: aRequestUrl.
	request setUrl: urlWithProperHtmlEncoding.
	request send; waitOnReadySpecRetrying: 5.
	result := (request lastResponse hasStatus
					and: [request lastResponse isSuccessful])
				ifTrue: [request lastResponse body]
				ifFalse: [''].
	Transcript show: result; cr.
	^result.
				
! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/25/2008 12:16'!
start
	|result|
	(self isAppRootSpecified)
		ifFalse: [self error: 'Specify appRoot before starting'].
	(self isStarted)
		ifTrue: [self error: 'Can not start again'].
	result := self commandToSeleniumRC: 'getNewBrowserSession&1=', self defaultBrowser, '&2=', self fullAppRoot.
	(result beginsWith: 'OK,')
		ifTrue: [sessionId  := result copyFrom: 4 to: result size]
		ifFalse: [self error: 'Error starting, unexpected result: ''', result, ''''].
! !

!WtSeleniumWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 21:28'!
stop
	|result|
	result := self commandToSeleniumRC: 'testComplete&sessionId=', sessionId.
	(result = 'OK')
		ifFalse: [self error: 'problem stopping browser', result]
		ifTrue: [sessionId := nil]! !

!WtSeleniumWebTester methodsFor: 'accessing' stamp: 'bkbag 4/17/2009 20:38'!
title
	|result|
	result := self commandToSeleniumRC: 'getTitle&sessionId=', sessionId.
	(result beginsWith: 'OK')
		ifFalse:[self error: 'Could not retrieve title, error was: ', result].
	^result copyFrom: 4 to: result size.! !

!WtWebTester methodsFor: 'accessing' stamp: 'BKBAG 11/23/2008 21:25'!
isStarted
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 4/17/2009 20:48'!
isTextPresent: aString
	self subclassResponsibility ! !

!WtWebTester methodsFor: 'actions' stamp: 'bkbag 4/17/2009 20:31'!
openUrl: anUrl
	self subclassResponsibility.! !

!WtWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 20:07'!
start
	self subclassResponsibility! !

!WtWebTester methodsFor: 'initialize-release' stamp: 'BKBAG 11/23/2008 20:07'!
stop
	self subclassResponsibility! !

!WtWebTester methodsFor: 'accessing' stamp: 'bkbag 4/17/2009 20:33'!
title
	self subclassResponsibility! !

TestCase subclass: #WtSeleniumCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtSeleniumCase commentStamp: 'BKBAG 5/10/2009 13:21' prior: 0!
A WtSeleniumCase is testcase you can extend to easily write selenium tests.

Instance Variables
	webTester:		<Object>

webTester
	- xxxxx
!

!WtSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:05'!
defaultAppRoot
	self subclassResponsibility! !

!WtSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:13'!
resources
	WtSeleniumWebTesterTestResource defaultAppRoot: (self defaultAppRoot).
	^Array with: WtSeleniumWebTesterTestResource! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:12'!
isTextPresent: aString
	^self webTester isTextPresent: aString! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 14:13'!
openUrl: anUrl
	self webTester openUrl: anUrl! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:32'!
title
	^self webTester title! !

!WtSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:13'!
webTester
	^WtSeleniumWebTesterTestResource webTester! !

WtSeleniumCase subclass: #WtSeleniumCaseExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSeleniumCaseExampleTest commentStamp: 'BKBAG 5/10/2009 16:16' prior: 0!
A WtSeleniumCaseExampleTest is an example test case to show you how to write selenium tests using test case.

You only have to implement 
WtSeleniumCase class >> 
	defaultAppRoot
	^'http://www.google.be'

Instance Variables
!

!WtSeleniumCaseExampleTest class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:15'!
defaultAppRoot
	^'http://www.google.be'! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 15:47'!
testGoogleQuery
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 15:47'!
testGoogleQuery2
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:15'!
testGoogleQuery3
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:15'!
testGoogleQuery4
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

!WtSeleniumCaseExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:15'!
testGoogleQuery5
	self openUrl: 'http://www.google.be/'.
	self should: (self isTextPresent: 'Google').! !

WtSeleniumCase subclass: #WtSeleniumOpenUrlAndTestTitleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSeleniumOpenUrlAndTestTitleTest commentStamp: 'BKBAG 5/10/2009 13:19' prior: 0!
A WtSeleniumOpenUrlAndTestTitleTest tests 
	- opening an url
	- retrieving the title of the page
	- isTextPresent

Instance Variables
!

!WtSeleniumOpenUrlAndTestTitleTest class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 16:30'!
defaultAppRoot
	^'http://www.google.be'! !

!WtSeleniumOpenUrlAndTestTitleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 16:31'!
testOpenUrl
	self openUrl: 'http://www.google.be/'.
	self should: ['Google' = self title].
	self assert: [self isTextPresent: 'Google.be aangeboden in'].
	self deny: [self isTextPresent: 'TextNietGevonden'].
! !

WtSeleniumCase subclass: #WtUnitTestComponentSeleniumCase
	instanceVariableNames: 'componentUnderTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium'!

!WtUnitTestComponentSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:21'!
componentClassUnderTest
	self subclassResponsibility! !

!WtUnitTestComponentSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:03'!
componentUnderTestResourcePath
	^'webtestercomponenttesting'! !

!WtUnitTestComponentSeleniumCase class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:06'!
defaultAppRoot
	^'http://localhost:8080/seaside/'.! !

!WtUnitTestComponentSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:24'!
componentUnderTest
	^componentUnderTest ! !

!WtUnitTestComponentSeleniumCase methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:17'!
componentUrl
	^self class defaultAppRoot , self class componentUnderTestResourcePath.! !

!WtUnitTestComponentSeleniumCase methodsFor: 'running' stamp: 'BKBAG 5/10/2009 17:21'!
setUp
	super setUp.
	componentUnderTest := WAAdmin 
		register: self class componentClassUnderTest
		asApplicationAt: self class componentUnderTestResourcePath.
	self openUrl: self componentUrl! !

!WtUnitTestComponentSeleniumCase methodsFor: 'running' stamp: 'BKBAG 5/10/2009 17:15'!
tearDown
	super tearDown.
	componentUnderTest 
		ifNotNil: [WAAdmin defaultDispatcher unregister: componentUnderTest]
! !

WtUnitTestComponentSeleniumCase subclass: #WtUnitTestComponentSeleniumExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtUnitTestComponentSeleniumExampleTest class methodsFor: 'accessing' stamp: 'BKBAG 5/10/2009 17:22'!
componentClassUnderTest
	^WtMockApplication! !

!WtUnitTestComponentSeleniumExampleTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 17:51'!
testMockApplicationTextContent
	WtMockApplication expectedText: 'text to be shown'.
	self should: (self isTextPresent: 'text to be shown').
	! !

TestCase subclass: #WtSeleniumStartStopTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtSeleniumStartStopTest commentStamp: 'BKBAG 5/10/2009 13:18' prior: 0!
A WtSeleniumStartStopTest tests starting and stopping browser.

Instance Variables
!

!WtSeleniumStartStopTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 20:23'!
appRoot
	^'www.google.com'! !

!WtSeleniumStartStopTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 21:52'!
defaultWebTester
	^ WtSeleniumWebTester new appRoot: 'http://www.google.com'! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:13'!
testAutoAppendHttpToRootAppUrl
	| seleniumWebTester |
	seleniumWebTester := WtSeleniumWebTester new appRoot: 'www.google.com'.
	[seleniumWebTester start]
	ensure: [seleniumWebTester stop]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:14'!
testCanNotStartTwice
	| seleniumWebTester |
	seleniumWebTester := self defaultWebTester.
	[seleniumWebTester start.
	self
		should: [seleniumWebTester start]
		raise: Error
		withExceptionDo: [:anException | self assert: anException messageText = 'Can not start again']]
		ensure: [seleniumWebTester stop]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:14'!
testCanStartStopAndStartStop
	| seleniumWebTester |
	seleniumWebTester := self defaultWebTester.
	[seleniumWebTester start]
		ensure: [seleniumWebTester stop].
	[seleniumWebTester start]
		ensure: [seleniumWebTester stop]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:15'!
testIsStarted
	|seleniumWebTester|
	seleniumWebTester := self defaultWebTester.
	
	[self shouldnt: seleniumWebTester isStarted.
	seleniumWebTester start.]
	ensure: [
		self should: seleniumWebTester isStarted.	
		seleniumWebTester stop.
		
		self shouldnt: seleniumWebTester isStarted.	
		]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 11/23/2008 21:52'!
testSpecifyRootAppBeforeStarting
	| seleniumWebTester |
	seleniumWebTester := WtSeleniumWebTester new.
	self 
		should: [ seleniumWebTester start ]
		raise: Error
		withExceptionDo: 
			[ :anException | 
			self assert: anException messageText = 'Specify appRoot before starting' ]! !

!WtSeleniumStartStopTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:16'!
testStartStop
	|seleniumWebTester|
	seleniumWebTester := self defaultWebTester.
	
	[seleniumWebTester start.]
	ensure: [seleniumWebTester stop.]! !

TestCase subclass: #WtTrySeleniumRCOutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebTester-Selenium-Tests'!

!WtTrySeleniumRCOutTest commentStamp: 'BKBAG 5/10/2009 13:18' prior: 0!
A WtTrySeleniumRCOutTest is a raw tryout of the selenium rc in squeak - first demo.

Instance Variables
!

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 17:31'!
clickButton: id forSession: aSessionId
	|result|
	result := self commandToSeleniumRC: 'click&1=', id, '&sessionId=',aSessionId.
	self should: [result = 'OK']! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 16:26'!
closeBrowser: sessionId
	| result|
	result := self commandToSeleniumRC: 'testComplete&sessionId=', sessionId.
	self should: [result = 'OK'].! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 15:53'!
commandToSeleniumRC: aCommandString
	^self requestToSeleniumRC: 'http://localhost:4444/selenium-server/?cmd=', aCommandString.! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 5/10/2009 12:54'!
openBrowserToUrl: anUrl
	|result|
	result := self commandToSeleniumRC: 'getNewBrowserSession&1=*chrome&2=', anUrl.
	self should: [result beginsWith: 'OK,'].
	^result copyFrom: 4 to: result size. ! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 17:30'!
openPage: url forSession: aSessionId
	|result|
	result := self commandToSeleniumRC: 'open&1=', url, '&sessionId=',aSessionId.
	self should: [result = 'OK']! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'bkbag 4/19/2009 15:27'!
requestToSeleniumRC: aRequestUrl
	| request result urlWithProperHtmlEncoding|
	Transcript show: aRequestUrl; cr.
	request := SptHTTPRequest new.
	request openGetTo: aRequestUrl.
	urlWithProperHtmlEncoding := SptHTTPUrl fromString: aRequestUrl.
	urlWithProperHtmlEncoding urlString: aRequestUrl.
	request setUrl: urlWithProperHtmlEncoding.
	request send; waitOnReadySpecRetrying: 5.
	result := (request lastResponse hasStatus
					and: [request lastResponse isSuccessful])
				ifTrue: [request lastResponse body]
				ifFalse: [''].
	Transcript show: result; cr.
	^result.
				
! !

!WtTrySeleniumRCOutTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:12'!
testDoAGoogleQuery
	| sessionId |
	[
		sessionId := self openBrowserToUrl: 'http://www.google.com'.
		self 
			openPage: 'http://www.google.com/webhp'
			forSession: sessionId.
		self 
			textInput: 'q'
			typeValue: 'Squeak'
			forSession: sessionId.
		self 
			clickButton: 'btnG'
			forSession: sessionId.
		self should: [ (self title: sessionId) includesSubString: 'Google' ].
		]
	ensure: [
		self closeBrowser: sessionId
		]! !

!WtTrySeleniumRCOutTest methodsFor: 'tests' stamp: 'BKBAG 5/10/2009 13:11'!
testOpenAndCloseBrowser
	| sessionId|

	[sessionId := self openBrowserToUrl: 'http://www.google.com'.]
	ensure: [self closeBrowser: sessionId.]! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 16:38'!
textInput: id typeValue: aValue forSession: aSessionId
	|result|
	result := self commandToSeleniumRC: 'type&1=', id, '&2=',aValue,'&sessionId=',aSessionId.
	self should: [result = 'OK']! !

!WtTrySeleniumRCOutTest methodsFor: 'helper' stamp: 'BKBAG 11/23/2008 17:36'!
title: sessionId
	|result|
	result := self commandToSeleniumRC: 'getTitle&sessionId=',sessionId.
	self should: [result beginsWith: 'OK'].
	^result copyFrom: 4 to: result size. ! !
